angular.module('app.controllers')

    .controller('DPaySceltaPvCtrl', function($scope, $state, $stateParams, $ionicPopup, $ionicLoading, $ionicViewService, $timeout, $translate, $ionicSideMenuDelegate, $http, $interpolate, SpeechService) {
        console.log("DPaySceltaPvCtrl", $stateParams);

        //$stateParams.pan
        var initializingMap = true;
        var infowindows = [];   //rgistra tutte le infowindow dei pv sulla mappa
        var pvTemplateMarker;
        // trackView('storico codice carta');
        trackView($state.current.name);
        // $ionicSideMenuDelegate.canDragContent(false)

        $scope.$on("onPause", function (event, data) { });
        $scope.$on("onResume", function (event, data) {
            init();
        });

        $http.get('templates/dpayment/map-marker-detail-point.html').then(function(response) {
            pvTemplateMarker = response.data;
        });

        $scope.$on('$stateChangeStart', function(ev){
            //$ionicView.afterEnter
            $ionicSideMenuDelegate.canDragContent(true);
        });

        $scope.$on('$stateChangeSuccess', function(ev){
            //$ionicView.beforeLeave
            // Don't allow the page to be dragged around
            $ionicSideMenuDelegate.canDragContent(false);
        });

        $scope.isInitializing = function(){
            return initializingMap;
        };

        function init(){
            disableAppResume();
            cordova.plugins.diagnostic.isLocationAvailable(function(available){
                if(available) {
                    enableAppResume();
                    navigator.geolocation.getCurrentPosition(geolocationSuccess,
                        onGeolocationError,
                        {maximumAge: 3000, timeout: CONFIG.GPS_TIMEOUT, enableHighAccuracy: true});
                } else {
                    cordova.plugins.diagnostic.requestLocationAuthorization(function(status){
                        enableAppResume();
                        switch(status){
                            case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                                navigator.geolocation.getCurrentPosition(geolocationSuccess,
                                    onGeolocationError,
                                    {maximumAge: 3000, timeout: CONFIG.GPS_TIMEOUT, enableHighAccuracy: true});
                                break;
                            case cordova.plugins.diagnostic.permissionStatus.GRANTED_WHEN_IN_USE:
                                navigator.geolocation.getCurrentPosition(geolocationSuccess,
                                    onGeolocationError,
                                    {maximumAge: 3000, timeout: CONFIG.GPS_TIMEOUT, enableHighAccuracy: true});
                                break;
                                default:
                                    onGeolocationError({ code: status } );
                        }
                    }, onGeolocationError, cordova.plugins.diagnostic.locationAuthorizationMode.ALWAYS);
                }

            }, onGeolocationError);

        }

        function initMap(position){

            var latLng;

            if (getEnv() !== 'prod') {
                console.info("Coordinate pilot!");
                latLng = new google.maps.LatLng(CONFIG.defaultLat + 0.0001, CONFIG.defaultLon + 0.0001);
            } else {
                //41.826988220214844,12.453096389770508 sede kupit
                // latLng = new google.maps.LatLng(41.826988220214844, 12.453096389770508);
                // latLng = new google.maps.LatLng(45.4122404,10.9785828);
                latLng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
            }

            var mapOptions = {
                center: latLng,
                zoom: CONFIG.defaultZoom,
                mapTypeId: google.maps.MapTypeId.ROADMAP
            };

            $scope.map = new google.maps.Map(document.getElementById("map"), mapOptions);

            //Wait until the map is loaded
            google.maps.event.addListenerOnce($scope.map, 'idle', function(){
                $scope.$apply(function(scope){
                    initializingMap = false;
                });

                //me
                var marker = new google.maps.Marker({
                    map: $scope.map,
                    animation: google.maps.Animation.DROP,
                    position: latLng
                });

                if (getEnv() !== 'prod') {
                        addMarkers([{
                            "codice": "9992",
                            "stato": null,
                            "indirizzo": "V.LE OCEANO INDIANO TEST Q8",
                            "localita": "ROMA",
                            "provincia": "RM",
                            "cap": "00144",
                            "telefono": "0654211065",
                            "latitudine": 41.827037,
                            "longitudine": 12.452827,
                            "divisione": null,
                            "tipologia": null,
                            "email": null,
                            "riferimentoResponsabile": null,
                            "dataInizioAttivita": 1455058800000,
                            "dataFineAttivita": null,
                            "flagAds": "N",
                            "flagHospitality": "N",
                            "tipologie": [{"codpv": "9992", "tipologia": "AUTOMAT"}],
                            "pagamenti": [{
                                "codiceMetodo": "AMX",
                                "descrizione": "American Express"
                            }, {"codiceMetodo": "PP", "descrizione": "PayPal"}, {
                                "codiceMetodo": "OTR",
                                "descrizione": "CartissimaQ8"
                            }, {"codiceMetodo": "BUO", "descrizione": "RecardQ8"}, {
                                "codiceMetodo": "ESH",
                                "descrizione": "euroShell card"
                            }, {"codiceMetodo": "TLP", "descrizione": "TelepassPay"}, {
                                "codiceMetodo": "DKV",
                                "descrizione": "DKV"
                            }],
                            "servizi": [{
                                "stato": null,
                                "codice": "CW",
                                "descrizione": "Lavaggio autovetture"
                            }, {"stato": null, "codice": "Q8EA", "descrizione": "Q8easy Club"}],
                            "prodotti": [{
                                "codiceProdotto": "300004",
                                "prezzoSelf": null,
                                "prezzoServ": null,
                                "prezzoPrepay": null,
                                "fSegit": null
                            }, {
                                "codiceProdotto": "300016",
                                "prezzoSelf": null,
                                "prezzoServ": null,
                                "prezzoPrepay": null,
                                "fSegit": null
                            }],
                            "promo": [],
                            "prezzi": [{
                                "codiceProdotto": "300016",
                                "prezzoSelf": 1.389,
                                "prezzoServ": 1.389,
                                "prezzoPrepay": 1.389,
                                "fSegit": "Y"
                            }, {
                                "codiceProdotto": "300004",
                                "prezzoSelf": 1.479,
                                "prezzoServ": 1.479,
                                "prezzoPrepay": 1.479,
                                "fSegit": "Y"
                            }],
                            "icons": null,
                            "ads": null,
                            "partner": false,
                            "idPromo": null,
                            "codPartner": null,
                            "note": null,
                            "nomePartner": null,
                            "descrPromo": null
                        },
                        {
                            "codice": "0065",
                            "stato": null,
                            "indirizzo": "V.LE OCEANO INDIANO TEST Q8",
                            "localita": "ROMA",
                            "provincia": "RM",
                            "cap": "00144",
                            "telefono": "0654211065",
                            "latitudine": 41.826080,
                            "longitudine": 12.450982,
                            "divisione": null,
                            "tipologia": null,
                            "email": null,
                            "riferimentoResponsabile": null,
                            "dataInizioAttivita": 1455058800000,
                            "dataFineAttivita": null,
                            "flagAds": "N",
                            "flagHospitality": "N",
                            "tipologie": [{"codpv": "0065", "tipologia": "AUTOMAT"}],
                            "pagamenti": [{
                                "codiceMetodo": "AMX",
                                "descrizione": "American Express"
                            }, {"codiceMetodo": "PP", "descrizione": "PayPal"}, {
                                "codiceMetodo": "OTR",
                                "descrizione": "CartissimaQ8"
                            }, {"codiceMetodo": "BUO", "descrizione": "RecardQ8"}, {
                                "codiceMetodo": "ESH",
                                "descrizione": "euroShell card"
                            }, {"codiceMetodo": "TLP", "descrizione": "TelepassPay"}, {
                                "codiceMetodo": "DKV",
                                "descrizione": "DKV"
                            }],
                            "servizi": [{
                                "stato": null,
                                "codice": "CW",
                                "descrizione": "Lavaggio autovetture"
                            }, {"stato": null, "codice": "Q8EA", "descrizione": "Q8easy Club"}],
                            "prodotti": [{
                                "codiceProdotto": "300004",
                                "prezzoSelf": null,
                                "prezzoServ": null,
                                "prezzoPrepay": null,
                                "fSegit": null
                            }, {
                                "codiceProdotto": "300016",
                                "prezzoSelf": null,
                                "prezzoServ": null,
                                "prezzoPrepay": null,
                                "fSegit": null
                            }],
                            "promo": [],
                            "prezzi": [{
                                "codiceProdotto": "300016",
                                "prezzoSelf": 1.389,
                                "prezzoServ": 1.389,
                                "prezzoPrepay": 1.389,
                                "fSegit": "Y"
                            }, {
                                "codiceProdotto": "300004",
                                "prezzoSelf": 1.479,
                                "prezzoServ": 1.479,
                                "prezzoPrepay": 1.479,
                                "fSegit": "Y"
                            }],
                            "icons": null,
                            "ads": null,
                            "partner": false,
                            "idPromo": null,
                            "codPartner": null,
                            "note": null,
                            "nomePartner": null,
                            "descrPromo": null
                        }]);
                } else {
                    DPaySDK.pvAround(latLng.lat(), latLng.lng(), CONFIG.AROUND_ME,
                        function(response){
                            if (response.values && response.values.length > 0) {
                                addMarkers(response.values);
                            } else {

                                //todo: vietare genera codice se carta.tipoPin è di tipo autista

                                $ionicPopup.alert({template: $translate.instant("error.digitalpayments.no.pv.found"),
                                    title: $translate.instant("alert-title-attenzione")}).then(function(){
                                    $state.transitionTo('generacodice-carte', { pan: $stateParams.pan });
                                });
                            }
                        },
                        function(error){
                            console.warn("DPaySDK.pvAround", error);

                            //todo: vietare genera codice se carta.tipoPin è di tipo autista

                            $ionicPopup.alert({template: $translate.instant("error.digitalpayments.no.pv.found"),
                                title: $translate.instant("alert-title-attenzione")}).then(function(){
                                $state.transitionTo('generacodice-carte', { pan: $stateParams.pan });
                            });
                        })
                }


            });

        }

        function closeAllInfowidows(){
            for (var i=0; i<infowindows.length; i++){
                infowindows[i].close();
            }
        }

        function addMarkers(elements) {
            infowindows = [];

            for (var i = 0; i < elements.length; i++) {
                var element = elements[i];

                var icon = element.tipologie[0].tipologia === 'AUTOMAT' ? "img/pv/totem-q8easy.png" : "img/pv/totem-q8.png";
                var marker = new google.maps.Marker({
                    map: $scope.map,
                    animation: google.maps.Animation.DROP,
                    position: new google.maps.LatLng(element.latitudine, element.longitudine),
                    icon: icon
                });

                google.maps.event.addListener(marker, 'click', (function (marker, i) {
                    return function () {
                        closeAllInfowidows();

                        var element = elements[i];
                        for (var j = 0; j < element.prodotti.length; j++) {
                            element.prodotti[j].prodottoDescr = $translate.instant('prodotto-' + element.prodotti[j].codiceProdotto);
                        }
                        var infowindow = new google.maps.InfoWindow();

                        //creazione infowindow
                        var content = document.createElement('div');

                        //interpolazione template per popup
                        //todo: i18n
                        $scope.element = element;
                        $scope.i18n = {
                            textPuntoVendita: 'Punto Vendita',
                            textProdotti: 'Prodotti',
                            textConfermaPuntoVendita: 'Conferma Punto Vendita',
                            abilitaMicrofono: 'Abilita il microfono',
                            textParla: 'Tieni premuto il microfono e registra il numero della pompa'

                        };
                        content.innerHTML = $interpolate(pvTemplateMarker)($scope);

                        var okbutton = content.getElementsByClassName('okbutton')[0];
                        google.maps.event.addDomListener(okbutton, 'click', function () {
                            selectPv(element.codice);
                        });
                        var cancelbutton = content.getElementsByClassName('kobutton')[0];
                        google.maps.event.addDomListener(cancelbutton, 'click', function () {
                            closeInfowindows();
                        });

                        var messageElement = content.getElementsByClassName('item-note')[0];
                        var btnrecording = content.getElementsByClassName('btnrecording')[0];
                        google.maps.event.addDomListener(btnrecording, 'touchstart', function (event) {
                            console.log("touchstart");
                            event.srcElement.classList.add('hold');
                            event.preventDefault();
                            startRecording(messageElement, element.codice);
                        });
                        google.maps.event.addDomListener(btnrecording, 'touchend', function (event) {
                            console.log("touchend");
                            event.srcElement.classList.remove('hold');
                            stopRecording(messageElement);
                        });
                        var micactivate = content.getElementsByClassName('micactivate')[0];
                        google.maps.event.addDomListener(micactivate, 'click', function () {
                            //inibisco momentaneamente il resume dell'app
                            disableAppResume();
                            cordova.plugins.diagnostic.requestMicrophoneAuthorization(function(status){
                                console.log("Authorization request for microphone use was " + (status == cordova.plugins.diagnostic.permissionStatus.GRANTED ? "granted" : "denied"));

                                if (isAndroid()) {
                                    cordova.plugins.diagnostic.requestExternalStorageAuthorization(function (status) {
                                        console.log("Authorization request for external storage use was " + (status == cordova.plugins.diagnostic.permissionStatus.GRANTED ? "granted" : "denied"));
                                            showMicrophone(status == cordova.plugins.diagnostic.permissionStatus.GRANTED);
                                    }, function (error) {
                                        showMicrophone(false);
                                    });
                                } else {
                                    showMicrophone(status == cordova.plugins.diagnostic.permissionStatus.GRANTED);
                                }

                            }, function(error){
                                showMicrophone(false);
                            });
                        });

                        function showMicrophone(enabled){
                            console.log("showmicrophone", enabled);
                            var micno = content.getElementsByClassName('mic-not-enabled')[0];
                            var micsi = content.getElementsByClassName('mic-enabled')[0];
                            if (enabled) {
                                micsi.classList.remove('hide');
                                micno.classList.add('hide');
                            } else {
                                micsi.classList.add('hide');
                                micno.classList.remove('hide');
                            }
                            enableAppResume(15000);
                        }

                        cordova.plugins.diagnostic.isMicrophoneAuthorized(function(authorized){
                            console.log("App is " + (authorized ? "authorized" : "denied") + " access to the microphone");
                            if (authorized) {
                                if (isAndroid()) {
                                    //solo android
                                    cordova.plugins.diagnostic.isExternalStorageAuthorized(function (authorized) {
                                        console.log("App is " + (authorized ? "authorized" : "denied") + " access to the external storage");
                                        if (authorized) {
                                            showMicrophone(true)
                                        } else {
                                            showMicrophone(false)
                                        }
                                    }, function (error) {
                                        console.error("The following error occurred: " + error);
                                        showMicrophone(false)
                                    });
                                } else {
                                    //solo iOS
                                    showMicrophone(true)
                                }
                            }
                            else {
                                showMicrophone(false)
                            }
                        }, function(error){
                            console.error("The following error occurred: "+error);
                        });

                        infowindow.setContent(content);
                        infowindow.open(map, marker);
                        infowindows.push(infowindow);
                    }
                })(marker, i));

            }

        }

        var selectPv = function(codice){

            console.log("### selectPv ", codice);
            closeInfowindows();

            var payFav = retrieve(PROFILEKEYS.FAVORITE_PAYMENTS_TYPE);
            if (CONFIG.DPAY_DEFAULT === payFav){
                $state.transitionTo('dpayment-listapompe', { pan: $stateParams.pan, pvCode: codice });
            } else {
                $state.transitionTo('dpayment-rifornimento', {pan: $stateParams.pan, pvCode: codice });
            }
        };

        var closeInfowindows = function(){
            for (var i=0; i<infowindows.length; i++) {
                infowindows[i].close();
            }
        };

        var geolocationSuccess = function(position) {

            console.log("geolocationSuccess", position);
            initMap(position);
        };

        var onGeolocationError = function(error) {
            enableAppResume();

            //confirm attivare il gps o andare ai codici di pagamento
            //in alcuni casi error è null
            var isTimeoutError = (error.code && error.code === 3)? true: false;

            $ionicPopup.confirm({
                template: isTimeoutError ? $translate.instant('error.digitalpayments.timeout.gps') : $translate.instant('error.digitalpayments.no.gps'),
                title: $translate.instant("alert-title-attenzione"),
                cancelText: isTimeoutError ? $translate.instant('dpay-btn-annulla') : $translate.instant('dpay-btn-attiva'),
                okText: $translate.instant('dpay-btn-genera-codice')
            }).then(function(res){
                if (res) {
                    //todo: vietare genera codice se carta.tipoPin è di tipo autista
                    $state.transitionTo('generacodice-carte', { pan: $stateParams.pan });
                } else {
                    if (isTimeoutError){
                        var view = $ionicViewService.getBackView();
                        if (view) view.go();
                    } else {
                        cordova.plugins.diagnostic.switchToSettings(
                            function () {
                                console.log("Successfully switched to Settings app");
                            }, function (error) {
                                console.error("switchToSettings The following error occurred ", error);
                                var view = $ionicViewService.getBackView();
                                if (view) view.go();
                            });
                    }
                }
            });
        };

        /* speech commands*/
        var isButtonPressed = false;
        var msgElementRef;
        var pvCodeRef;

        var onRecordingSuccess = function(response){
            console.info("onRecordingSuccess", response);
            writeMessage(msgElementRef, $translate.instant("speech-digitalpayments-message-processed"), false);
            $timeout(function(){
                if ( response.value ){
                    $state.transitionTo('dpayment-listapompe', { pan: $stateParams.pan, pvCode: pvCodeRef, pump: response.value });
                }
            }, 500);
        };

        var onRecordingError = function(error){
            console.error("onRecordingError", error);
            writeMessage(msgElementRef,  $translate.instant("speech-digitalpayments-message-error"), true);
            SpeechService.release();
        };

        var startRecording = function(msgElement, pvCode){
            console.log("startRecording", new Date().getTime());
            isButtonPressed = true;
            msgElementRef = msgElement;
            pvCodeRef = pvCode;

            writeMessage(msgElement, $translate.instant("speech-digitalpayments-message-press"), false);

            $timeout(function(){
                if (isButtonPressed) {
                    console.info("startRecording start", new Date().getTime());
                    writeMessage(msgElement, $translate.instant("speech-digitalpayments-message-continue"), false);
                    SpeechService.startRecording(10000, onRecordingSuccess, onRecordingError)
                } else {
                    $ionicPopup.alert({
                        template: $translate.instant("fueling-speech-usage-info"),
                        title: $translate.instant("alert-title-attenzione")
                    });
                }
            }, 500);
        };

        var stopRecording = function(msgElement){
            console.info("stopRecording", new Date().getTime());
            if (isButtonPressed) {
                $timeout(function(){
                    writeMessage(msgElement, $translate.instant("speech-digitalpayments-message-processing"), false);
                    SpeechService.stopRecording( onRecordingSuccess, onRecordingError )
                }, 500);
            }
            isButtonPressed = false;
        };

        init();
    })

    .controller('DPaySceltaRifornimentoCtrl', function($scope, $state, $stateParams) {
        console.log("DPaySceltaRifornimentoCtrl", $stateParams);

        //$stateParams.pan, $stateParams.pvCode

        $scope.dpaydefault = CONFIG.DPAY_DEFAULT === retrieve(PROFILEKEYS.FAVORITE_PAYMENTS_TYPE);

        $scope.dpay = function(){
            //transition to dpay
            $state.transitionTo('dpayment-listapompe', { pan: $stateParams.pan, pvCode: $stateParams.pvCode });
        };

        $scope.creaCodice = function(){
            //transition to codici pagamento
            //todo: vietare genera codice se carta.tipoPin è di tipo autista
            $state.transitionTo('generacodice-carte', { pan: $stateParams.pan });
        };

        $scope.setDefaultPaymentDpay = function(flag){

            if (flag){
                store(PROFILEKEYS.FAVORITE_PAYMENTS_TYPE, CONFIG.DPAY_DEFAULT);
                $scope.dpaydefault = true;
            } else {
                window.localStorage.removeItem(PROFILEKEYS.FAVORITE_PAYMENTS_TYPE);
                $scope.dpaydefault = false;
            }
        }
    })

    .controller('DPayListaPompeCtrl', function($scope, $rootScope, $state, $stateParams, $ionicPopup, $ionicModal, $ionicLoading, $ionicViewService, $timeout, $interval, $translate, BiometricService) {
        console.log("DPayListaPompeCtrl", $stateParams);

        $scope.items = {};
        var currentPumpId;  //pompa corrente

        var initializing = true;
        var fingerprintEnabled = false;

        //verifico la presenza della password salvata
        if (window.plugins && window.plugins.touchid) {
            if (BiometricService.getBiometricCodesProtectionConfig()) {
                window.plugins.touchid.has(CONFIG.biometricLoginKey, function () {
                    fingerprintEnabled = true;
                }, function () {
                    fingerprintEnabled = false;
                });
            }
        }

        trackView($state.current.name);

        $scope.isInitializing = function(){
            return initializing;
        };

        function init(){

           //verifico se l'ultima transazione è in corso
            DPaySDK.lastTransaction(getCurrentUser().sdkToken, $stateParams.pan, function (response) {
                console.log("lastTransaction", response);

                if (response.errorMessage !== null) {
                    $ionicPopup.alert({
                        template: $translate.instant(response.errorMessage),
                        title: $translate.instant("alert-title-attenzione")
                    }).then(function () {
                        var view = $ionicViewService.getBackView();
                        if (view) view.go();
                    });
                } else {
                    if (response.value) {
                        if (response.value.erogazioneInCorso) {
                            var preAuth = retrieve('preAuth');
                            if (preAuth === null) {
                                //todo: preAuth mancante -> è successo qualcosa nel frattempo (logout, cambio telefono,...)
                                //recuperare lo stato della transazione
                                preAuth = { request_id: response.value.txId, authorizedAmount: 0, fuelingPoint_id: response.value.fuelingpointId }
                            }
                            $state.dPayment = response.value;
                            $state.transitionTo('dpayment-erogazione', {
                                dPayment: JSON.stringify($state.dPayment),
                                preAuth: JSON.stringify(preAuth)
                            });
                            return;
                        }
                    }
                    getFuelingPoints();

                }

            }, function (error) {
                console.error("lastTransaction", error);
                $ionicPopup.alert({
                    template: $translate.instant(error),
                    title: $translate.instant("alert-title-attenzione")
                }).then(function () {
                    var view = $ionicViewService.getBackView();
                    if (view) view.go();
                });
            })


        }

        function getFuelingPoints(){
            initializing = true;

            //se $stateParams.pump provengo dal comando vocale
            var pump = $stateParams.pump;

            DPaySDK.fuelingPoints(getCurrentUser().sdkToken, $stateParams.pvCode, function (response) {

                initializing = false;
                if (response.errorMessage !== null) {
                    $ionicPopup.alert({
                        template: $translate.instant(response.errorMessage),
                        title: $translate.instant("alert-title-attenzione")
                    }).then(function () {
                        var view = $ionicViewService.getBackView();
                        if (view) view.go();
                    });

                } else {
                    console.log("fuelingPoints", response);
                    $scope.$apply(function(scope){
                        scope.dPayment = {
                            request_id: response.value.request_id,
                            erogazioneInCorso: false
                        };
                        scope.items = response.value.fuelingPoints;
                        if (pump){
                            var pumpNumber = Number(pump);
                            for (var i=0; i<response.value.fuelingPoints.length; i++){
                                var fp = response.value.fuelingPoints[i];
                                //todo: controllare che la pompa selezionata sia libera

                                if (fp.id === pumpNumber){
                                    $scope.selectPump(pumpNumber);
                                    return;
                                }
                            }

                            $ionicPopup.alert({
                                template: $translate.instant('error.digitalpayments.fuelingpoint.not.exists', { pump: pump}),
                                title: $translate.instant("alert-title-attenzione")
                            })
                        }
                    });

                }
            },
            function(error){
                console.error("paymentStatus", error);
                $ionicPopup.alert({
                    template: $translate.instant(error),
                    title: $translate.instant("alert-title-attenzione")
                }).then(function () {
                    var view = $ionicViewService.getBackView();
                    if (view) view.go();
                });

            })

        }

        $scope.isPumpOpen = function(pumpId){
            return currentPumpId === pumpId;
        };

        $scope.openPump = function(pumpId){
            if (currentPumpId === pumpId){
                currentPumpId = null;
            } else {
                currentPumpId = pumpId;
            }
        };


        $scope.selectPump = function(pumpId){
            $stateParams.pump = null;   //resetto il parametro per invalidare altre richieste
            if (window.plugins && window.plugins.touchid) {

                window.plugins.touchid.isAvailable(
                    function(){

                        if (fingerprintEnabled && BiometricService.getBiometricCodesProtectionConfig()) {
                            window.plugins.touchid.verify(CONFIG.biometricLoginKey,
                                $translate.instant("dpay-conferma-pompa-biometric-text", { pompa: pumpId }),
                                    function (password) {
                                    _selectPump(pumpId)
                            });

                        } else {
                            //touch id available but not enabled
                            confermaSceltaPompa(pumpId, true)
                        }
                    },
                    function(msg){
                        // touch Id not availlable
                        confermaSceltaPompa(pumpId, true)
                    })

            } else {
                //touch id plugin not present
                confermaSceltaPompa(pumpId, true)
            }

        };

        function confermaSceltaPompa(pumpId){
            $ionicPopup.confirm({
                title: $translate.instant('dpay-conferma-pompa-title'),
                template: $translate.instant("dpay-conferma-pompa-text", { pompa: pumpId })
            }).then(function(res) {
                if(res) {
                    _selectPump(pumpId)
                }
            });
        }

        function _selectPump(pumpId){

            if (!$scope.isPumpOpen(pumpId)) $scope.openPump(pumpId);

                $ionicLoading.show();
                DPaySDK.startPayment(
                    getCurrentUser().sdkToken, $scope.dPayment.request_id, $stateParams.pvCode, pumpId, $stateParams.pan, 0,
                    function (response) {
                        $ionicLoading.hide();
                        console.info("startPayment", response);

                        if (response.errorMessage !== null) {
                            $ionicPopup.alert({
                                template: $translate.instant(response.errorMessage),
                                title: $translate.instant("alert-title-attenzione")
                            }).then(function () {
                                // var view = $ionicViewService.getBackView();
                                // if (view) view.go();
                                getFuelingPoints(); //ricarico la lista pompe per cambiare il trxId
                            });

                        } else {
                            store ('preAuth', response.value);
                            $state.transitionTo('dpayment-erogazione', { preAuth: JSON.stringify(response.value)});
                        }
                    },
                function (error){
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        template: $translate.instant(error),
                        title: $translate.instant("alert-title-attenzione")
                    }).then(function () {
                        // var view = $ionicViewService.getBackView();
                        // if (view) view.go();
                        getFuelingPoints(); //ricarico la lista pompe per cambiare il trxId
                    });
                })

        };

        init();

    })

    .controller('DPayErogazioneCtrl', function($scope, $rootScope, $state, $stateParams, $ionicPopup, $ionicModal, $ionicLoading, $ionicViewService, $ionicSideMenuDelegate, $timeout, $interval, $translate) {
        console.log("DPayErogazioneCtrl", $stateParams);

        //$stateParams.pan, $stateParams.pvCode
        $scope.dPayment = $stateParams.dPayment ? JSON.parse($stateParams.dPayment) : {};  //dPayment
        $scope.preAuth = JSON.parse($stateParams.preAuth);    //preAuthReponse
        $scope.isAborting = false;

        var stopFuelingChecks;
        var initializing = false;
        var isResumed = false;
        var userAborted = false;

        trackView($state.current.name);

        $scope.$on('$stateChangeStart', function(ev){
            //$ionicView.afterEnter
            $ionicSideMenuDelegate.canDragContent(true);
        });

        $scope.$on('$stateChangeSuccess', function(ev){
            //$ionicView.beforeLeave
            // Don't allow the page to be dragged around
            $ionicSideMenuDelegate.canDragContent(false);
            doStopFuelingChecks();
        });

        $scope.$on("onPause", function (event, data) {
            // onPause();
            //al momento non spengo il timer e lascio il controllo in background
            // doStopFuelingChecks();
        });
        $scope.$on("onResume", function (event, data) {
            initializing = true;
            isResumed = true;
            init();
        });

        $ionicModal.fromTemplateUrl('templates/dpayment/fueling-completed-confirm.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(popover) {
            $scope.modalFuleingCompleted = popover;
            $rootScope.registerModal(popover);
        });

        $scope.closeModalFuleingCompleted = function(){
            $scope.modalFuleingCompleted.hide();
            if (userAborted){
                //todo: gestire la casistica in modo diverso?
                // var view = $ionicViewService.getBackView();
                // if (view) view.go();
            } else {

            }

            $rootScope.goto('private-dashboard');
        };

        $scope.isInitializing = function(){
            return initializing;
        };


        function doStopFuelingChecks(){
            if ( angular.isDefined(stopFuelingChecks) ) {
                $interval.cancel(stopFuelingChecks);
                stopFuelingChecks = undefined;
            }
        }

        function init(){
           startFuelingChecks($scope.preAuth.request_id);
        }

        function startFuelingChecks(trxId){
            if ( angular.isDefined(stopFuelingChecks) ){
                initializing = false;
                return;
            }

            DPaySDK.paymentStatus(getCurrentUser().sdkToken, trxId, $stateParams.pan, function (response) {
                console.log("paymentStatus", response);

                    $scope.$apply(function(scope){
                        scope.dPayment = response.value;
                    });

                    stopFuelingChecks = $interval(function () {
                    fuelingCheck(trxId)
                }, CONFIG.DPAY_POLLING);
            },
            function(error){
                console.error("paymentStatus", error);
                //nessuna erogazione presente, mando alla dashboard
                if (isResumed) {
                    $state.go("private-dashboard")
                }
            })
        }

        //aggiorna lo stato dell'erogazione
        function fuelingCheck(trxId){
            initializing = false;

            DPaySDK.paymentStatus(getCurrentUser().sdkToken, trxId, $stateParams.pan, function (response) {

                console.log("fuelingCheck::paymentStatus", response);

                $scope.$apply(function(scope){
                    scope.dPayment = response.value;
                });

                //erogazione completata
                if (response.value.erogazioneCompletata) {
                    doStopFuelingChecks();
                    $scope.modalFuleingCompleted.show();
                }

                //erogazione in errore
                if (response.value.erogazioneInErrore) {
                    $interval.cancel(stopFuelingChecks);
                    $ionicPopup.alert({
                        template: $translate.instant('dpay-fueling-status-' + response.value.stato),
                        title: $translate.instant("alert-title-attenzione")
                    }).then(function () {
                        var view = $ionicViewService.getBackView();
                        if (view) view.go();
                    });
                }
            },
            function(error){
                console.error("paymentStatus", error);
            })

        }

        $scope.abort = function(){
            $scope.isAborting = true;
            $ionicLoading.show();

            DPaySDK.abortPayment(getCurrentUser().sdkToken, $scope.dPayment.txId,
                function (response) {

                    $ionicLoading.hide();
                    console.log("abortPayment", response);
                    if (response.errorMessage !== null) {
                        $ionicPopup.alert({
                            template: $translate.instant(response.errorMessage),
                            title: $translate.instant("alert-title-attenzione")
                        });

                    } else {
                        // doStopFuelingChecks(); //il polling non ha più senso ormai

                        $ionicPopup.alert({
                            template: $translate.instant('msg-dpay-transaction-aborted-succesfully'),
                            title: $translate.instant("alert-title-attenzione")
                        }).then(
                            function () {
                                userAborted = true;

                                // var view = $ionicViewService.getBackView();
                                // if (view) view.go();
                            }
                        );

                    }

                }, function (error){
                    $scope.isAborting = false;
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        template: $translate.instant(error),
                        title: $translate.instant("alert-title-attenzione")
                });
            })

        };

        init();

    })

    .controller('StoricoSblocchiDPayCtrl', function($scope, $state, $stateParams, $ionicPopup, $ionicLoading, $ionicViewService, $translate) {
        console.log("StoricoSblocchiDPayCtrl", $stateParams);


        // trackView('storico codice carta');
        trackView($state.current.name);

        var profile = retrieve('profile');

        //se sono sub o driver
        $scope.pan = $stateParams.pan || profile.pan;

        $scope.results = [];

        $scope.$on("onPause", function (event, data) {
        });
        $scope.$on("onResume", function (event, data) {
            loadStorico();
        });

        var loadStorico = function(){
            $ionicLoading.show();

            DPaySDK.transactionsHistory(getCurrentUser().sdkToken, $scope.pan,
                    function (response) {
                        $ionicLoading.hide();
                        if (response.errorMessage !== null) {
                            $ionicPopup.alert({
                                template: $translate.instant(response.errorMessage),
                                title: $translate.instant("alert-title-attenzione")
                            });
                        } else {

                            $scope.results = response.value;
                        }

                    },
                    function (error) {
                        $ionicLoading.hide();
                        $ionicPopup.alert({
                            template: $translate.instant(error),
                            title: $translate.instant("alert-title-attenzione")
                        });

                    })

        };

        loadStorico();

    })

;

    
