angular.module('app.services')

  .service('StoreLocatorService', function($http, $translate) {

      this.retrievePvAround = function(lat, lng, radius){

          return $http.get(CONFIG.context.storeLocatorUrl + "/pv/around",
              { params: { lat: lat, lng: lng, r: radius }},
              { timeout: CONFIG.HTTP_TIMEOUT }).then(
              function (response) {
                  return response.data;
              }, function(error){
                  console.log("ERROR checkPrivacy " + JSON.stringify(error));
                  return {
                      errorMessage: $translate.instant("error.service.not.available")
                  }
              });
      };
  })  

;

