angular.module('app.services')

  .service('AlertService', function($http, $ionicLoading, $state, $ionicPopup, $translate) {
    return {
      ricerca: function(form) {

        $ionicLoading.show();

        var profile = getCurrentUser();

        return $http.post(CONFIG.apiUrl + '/alerts',
          {
            token: profile.authToken,
            sub: form.sub,
            pan: form.pan,
            periodo: form.periodo,
            type: form.tipo
          }
        ).success(function (response) {
          $ionicLoading.hide();
          if (response.errorMessage != null) {
            console.log(response.errorMessage);
          }
        }).error(function(data, status, headers, config){
          $ionicLoading.hide();
            $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                title: $translate.instant("alert-title-attenzione")});
        });
      },
      ricercaCarte: function(form) {

        $ionicLoading.show();

        var profile = getCurrentUser();

        return $http.post(CONFIG.apiUrl + '/alertscarta',
          {
            token: profile.authToken,
            sub: form.sub,
            pan: form.pan,
            periodo: form.periodo,
            type: form.tipo,
            pv: form.pv
          }
        ).success(function (response) {
          $ionicLoading.hide();
          if (response.errorMessage != null) {
            console.log(response.errorMessage);
          }
        }).error(function(data, status, headers, config){
          $ionicLoading.hide();
          $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
              title: $translate.instant("alert-title-attenzione")});

        });
      }      
    }
  })

;

