angular.module('app.services')

	.service('AutistiService', function ($http, $ionicLoading, $ionicPopup, $translate) {
		return {
			ricerca: function (form, pageIndex) {

				$ionicLoading.show();

				if (form.codice) form.codice = leftPadding(form.codice);

				var profile = getCurrentUser();
				var url = CONFIG.apiUrl + '/v2/autisti';
				if (pageIndex) {
					url += '/' + pageIndex;
				}

				return $http.post(url,
					{
						token: profile.authToken,
						codice: form.codice,
						t: form.tipoPin
					},
					{timeout: CONFIG.HTTP_TIMEOUT}
				)
				.success(function (response) {
					$ionicLoading.hide();

					if (response.errorMessage != null) {
						console.log(response.errorMessage);
                        $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                            title: $translate.instant("alert-title-attenzione")});

					}
				})
				.error(function () {
					$ionicLoading.hide();
                    $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                        title: $translate.instant("alert-title-attenzione")});
				});
			}

        }
	})

;

