angular.module('app.services')

  .service('TransazioniService', function($http, $ionicLoading, $ionicPopup, $translate) {
    return {
      ricerca: function(form, pageIndex) {

        $ionicLoading.show();

        var profile = getCurrentUser();
        var url = CONFIG.apiUrl + '/transazioni';
        if (pageIndex){
          url += '/'+pageIndex;
        }
        
        return $http.post(url,
          {
            token: profile.authToken,
            sub: form.sub,
            pan: form.pan,
            periodo: form.periodo
          }
        ).success(function (response) {
          $ionicLoading.hide();
          if (response.errorMessage != null) {
            console.log(response.errorMessage);
          }
        }).error(function(data, status, headers, config){
          $ionicLoading.hide();
            $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                title: $translate.instant("alert-title-attenzione")});
        });
      }
      // page: function(pageIndex, form) {
      //   //todo: gestire paginazione all'interno del metodo ricerca
      //   $ionicLoading.show();
      //
      //   var profile = getLoggedUser();
      //
      //   return $http.post(CONFIG.apiUrl + '/transazioni/'+pageIndex,
      //     {
      //       token: profile.authToken,
      //       sub: form.sub,
      //       pan: form.pan,
      //       periodo: form.periodo
      //     }
      //   ).success(function (response) {
      //     $ionicLoading.hide();
      //     if (response.errorMessage != null) {
      //       console.log(response.errorMessage);
      //     }
      //   }).error(function(){
      //     $ionicLoading.hide();
      //   });
      // }
    }
  })

;

